package org.cakelab.codegen;

import java.io.IOException;

public class AttributeGen extends MemberGen {
	protected String initialiser;

	public AttributeGen(String modifiers, Class<?> type, String name) {
		this(modifiers, type.getCanonicalName(), name, null);
	}

	public AttributeGen(Class<?> type, String name) {
		this(null, type, name);
	}

	public AttributeGen(String typeName, String name) {
		this(null, typeName, name, null);
	}
	
	
	public AttributeGen(String modifiers, String typeName, String name, String initialiser) {
		super(modifiers, typeName, name);
		this.initialiser = initialiser;
	}

	@Override
	public void write(IndentStreamControl pout) throws IOException {
		super.write(pout);
		pout.println(";");
	}
	
}
