package org.cakelab.codegen;

import java.io.IOException;

public class VariableGen implements CodeGen {
	protected String modifiers;
	protected String typeName;
	protected String name;
	protected String initialiser;

	public VariableGen(String modifiers, Class<?> type, String name) {
		this(modifiers, type.getCanonicalName(), name, null);
	}

	public VariableGen(Class<?> type, String name) {
		this(null, type, name);
	}

	public VariableGen(String typeName, String name) {
		this(null, typeName, name, null);
	}
	
	
	public VariableGen(String modifiers, String typeName, String name, String initialiser) {
		this.modifiers = modifiers;
		this.typeName = typeName;
		this.name = name;
		this.initialiser = initialiser;
	}

	public String getSignature() {
		return (modifiers != null ? modifiers + " " : "") + typeName + " " + name;
	}

	@Override
	public void write(IndentStreamControl pout) throws IOException {
		pout.println(getSignature() + (initialiser != null ? initialiser : ""));
	}

	public String getName() {
		return name;
	}

}
