package org.cakelab.nio.generator.codegen;

import java.io.IOException;

import org.cakelab.codegen.ClassGen;
import org.cakelab.codegen.IndentStreamControl;
import org.cakelab.codegen.VariableGen;
import org.cakelab.nio.generator.codegen.struct.ViewClassMethodGen;

public class CloneMethodGen extends ViewClassMethodGen {


	public CloneMethodGen(ClassGen classgen, VariableGen ... parameters) {
		super(classgen, "public", classgen.getClassName(), "clone", parameters);
		if (this.parameters.length == 0) {
			addAnnotation("@Override");
		}
	}

	@Override
	public void writeMethodBody(IndentStreamControl pout) throws IOException {
		
		if (this.parameters.length == 0) {
			pout.println("return super.clone(new " + this.typeName + "(this));");
		} else {
			assert(this.parameters.length == 1);
			pout.println("return super.clone(" + parameters[0].getName() + ");");
		}
	}


}
