package org.cakelab.nio.generator.codegen;

import java.io.IOException;

import org.cakelab.codegen.ClassGen;
import org.cakelab.codegen.IndentStreamControl;
import org.cakelab.codegen.VariableGen;
import org.cakelab.nio.generator.codegen.struct.ViewClassMethodGen;
import org.cakelab.nio.meta.FieldMeta;
import org.cakelab.nio.meta.TypeMeta;

public class CloseMethodGen extends ViewClassMethodGen {


	private TypeMeta typeMeta;

	public CloseMethodGen(ClassGen classgen, TypeMeta typeMeta, VariableGen ... parameters) {
		super(classgen, "public", void.class, "close", parameters);
		this.typeMeta = typeMeta;
		addAnnotation("@Override");
	}

	@Override
	public void writeMethodBody(IndentStreamControl pout) throws IOException {
		for (FieldMeta f : typeMeta.fields) {
			if (usesElemView(f)) pout.println(f.name + ".close();");
		}
		pout.println("super.close();");
	}


}
