package org.cakelab.nio.generator.codegen;

import java.io.IOException;

import org.cakelab.codegen.ClassGen;
import org.cakelab.codegen.IndentStreamControl;
import org.cakelab.nio.generator.codegen.struct.ViewClassMethodGen;
import org.cakelab.nio.meta.FieldMeta;
import org.cakelab.nio.meta.TypeMeta;

public class FactoryMethodGen extends ViewClassMethodGen {

	public static final String METHOD_NAME = "newDataInstance";
	private TypeMeta dataType;

	public FactoryMethodGen(ClassGen classgen, TypeMeta dataType) {
		super(classgen, "public", dataType.type, METHOD_NAME);
		this.dataType = dataType;
		addAnnotation("@Override");
	}

	@Override
	public void writeMethodBody(IndentStreamControl pout) throws IOException {
		
		String typeName = dataType.type.getCanonicalName();
		String resultVar = "result";
		pout.println(typeName + " " + resultVar + " = new " + typeName + "();");
		
		for (FieldMeta f : dataType.fields) {
			if (f.isReusable()) pout.println(resultVar + '.' + f.name + " = " + Utils.generateInitialiser(f) + ";");
		}
		pout.println("return " + resultVar + ";");

	}



}
