package org.cakelab.nio.generator.codegen;

import java.io.IOException;

import org.cakelab.codegen.ClassGen;
import org.cakelab.codegen.IndentStreamControl;
import org.cakelab.nio.generator.codegen.struct.ViewClassMethodGen;
import org.cakelab.nio.meta.TypeMeta;

public class JavaTypeMethodGen extends ViewClassMethodGen {


	private TypeMeta typeMeta;

	public JavaTypeMethodGen(ClassGen classgen, TypeMeta typeMeta) {
		super(classgen, "public", "Class<" + typeMeta.type.getCanonicalName() + ">", "javatype");
		this.typeMeta = typeMeta;
		addAnnotation("@Override");
	}

	@Override
	public void writeMethodBody(IndentStreamControl pout) throws IOException {
		pout.println("return " + typeMeta.type.getCanonicalName() + ".class;");
	}


}
