package org.cakelab.nio.generator.codegen;

import java.io.IOException;

import org.cakelab.codegen.ClassGen;
import org.cakelab.codegen.IndentStreamControl;
import org.cakelab.codegen.VariableGen;
import org.cakelab.nio.generator.codegen.struct.StructViewClassGen;
import org.cakelab.nio.generator.codegen.struct.ViewClassMethodGen;
import org.cakelab.nio.meta.FieldMeta;
import org.cakelab.nio.meta.TypeMeta;

public class OffsetMethodGen extends ViewClassMethodGen {


	private TypeMeta typeMeta;

	public OffsetMethodGen(ClassGen classgen, TypeMeta typeMeta) {
		super(classgen, "public", void.class, "offset", new VariableGen(int.class, "offset"));
		this.typeMeta = typeMeta;
		addAnnotation("@Override");
	}

	@Override
	public void writeMethodBody(IndentStreamControl pout) throws IOException {
		pout.println("super." + name + "(" + parameters[0].getName() + ");");
	
		for (FieldMeta f : typeMeta.fields) {
			if (usesElemView(f)) pout.println(f.name + "." + name + "(" + StructViewClassGen.ATTRIBUTE_STRUCT_OFFSET + " + " + f.offset + ");");
		}
	}


}
