package org.cakelab.nio.generator.codegen;

import java.io.IOException;

import org.cakelab.codegen.ClassGen;
import org.cakelab.codegen.IndentStreamControl;
import org.cakelab.codegen.VariableGen;
import org.cakelab.nio.generator.codegen.struct.StructViewClassGen;
import org.cakelab.nio.generator.codegen.struct.ViewClassMethodGen;
import org.cakelab.nio.meta.FieldMeta;
import org.cakelab.nio.meta.TypeMeta;

public class OpenMethodGen extends ViewClassMethodGen {


	private TypeMeta typeMeta;

	public OpenMethodGen(ClassGen classgen, TypeMeta typeMeta, VariableGen ... parameters) {
		super(classgen, "public", void.class, "open", parameters);
		if (parameters.length != 2) {
			throw new Error("internal error: must have 2 parameters");
		}
		this.typeMeta = typeMeta;
		addAnnotation("@Override");
	}

	@Override
	public void writeMethodBody(IndentStreamControl pout) throws IOException {

		pout.println("super.open(" + parameters[0].getName() + ", " + parameters[1].getName() + ");");
	
		for (FieldMeta f : typeMeta.fields) {
			if (usesElemView(f)) pout.println(getElemViewAttribute(f) + ".open(" + parameters[0].getName() + ", " + StructViewClassGen.ATTRIBUTE_STRUCT_OFFSET + " + " + f.offset + ");");
		}

	}


}
