package org.cakelab.nio.generator.codegen;

import java.io.IOException;

import org.cakelab.codegen.ClassGen;
import org.cakelab.codegen.IndentStreamControl;
import org.cakelab.nio.generator.codegen.struct.ViewClassMethodGen;
import org.cakelab.nio.meta.TypeMeta;

public class SizeofMethodGen extends ViewClassMethodGen {

	private int size;

	public SizeofMethodGen(ClassGen classgen, TypeMeta typeMeta, String methodName) {
		super(classgen, "public", int.class, methodName);
		this.size = typeMeta.size;
		addAnnotation("@Override");
	}

	@Override
	public void writeMethodBody(IndentStreamControl pout) throws IOException {

		pout.println("return " + size + ";");
	}

}
