package org.cakelab.nio.generator.codegen;

import java.io.IOException;

import org.cakelab.codegen.AttributeGen;
import org.cakelab.codegen.IndentStreamControl;
import org.cakelab.nio.meta.FieldMeta;

public class ViewAttributeGen extends AttributeGen {
	private int offset;

	public ViewAttributeGen(String viewTypeName, FieldMeta fieldMeta) {
		super("private", viewTypeName, fieldMeta.name, " = " + Utils.generateViewInitialiser(fieldMeta));
		this.offset = fieldMeta.offset;
	}

	@Override
	public void write(IndentStreamControl pout) throws IOException {
		pout.println(getSignature() + (initialiser != null ? initialiser : "") + ";");
	}

	@Override
	public int getSortPosition() {
		return offset + 10;
	}
	
	
}
