package org.cakelab.nio.generator.codegen;

import org.cakelab.codegen.ClassGen;
import org.cakelab.codegen.SourceCodeUnit;
import org.cakelab.nio.generator.Generator;
import org.cakelab.nio.meta.TypeMeta;
import org.cakelab.nio.view.GenericDataView;
import org.cakelab.nio.view.ReusableDataView;

public abstract class ViewClassGen extends ClassGen {
	public static final String ATTRIBUTE_BUFFER = "__nio__buffer";
	public static final String ATTRIBUTE_STRUCT_OFFSET = "__nio__offset";
	public static final String ATTRIBUTE_STRUCT_ALIGNMENT = "__nio__alignment";
	
	protected Generator generator;

	public ViewClassGen(Generator generator, SourceCodeUnit sourceCodeUnit, String modifiers, String pkg, String className, String superClassExpression) {
		super(sourceCodeUnit, modifiers, pkg, className, superClassExpression);
		this.generator = generator;
	}

	protected static Class<?> getViewInterface(TypeMeta structMeta) {
		if (structMeta.reusable) {
			return ReusableDataView.class;
		} else {
			return GenericDataView.class;
		}
	}

	@Override
	public void run() {
		populateBody();
	}

}
