package org.cakelab.nio.generator.codegen.struct;

import java.io.IOException;

import org.cakelab.codegen.ClassGen;
import org.cakelab.codegen.IndentStreamControl;
import org.cakelab.codegen.VariableGen;
import org.cakelab.nio.generator.codegen.Utils;
import org.cakelab.nio.meta.FieldMeta;

public class ArrayFieldSetterMethodGen extends ArrayFieldMethodGen {


	public ArrayFieldSetterMethodGen(ClassGen classgen, FieldMeta fieldMeta) {
		this(classgen,  fieldMeta, 0);
	}

	public ArrayFieldSetterMethodGen(ClassGen classgen, FieldMeta fieldMeta, int numIndexParameters) {
		super(classgen, 
				fieldMeta, 
				void.class.getCanonicalName(), 
				"set" + Utils.toCamelCase(fieldMeta.name), 
				numIndexParameters, 
				new VariableGen(getAccessedComponentType(fieldMeta.getType(), numIndexParameters), "value")
		);
	}


	@Override
	public void writeMethodBody(IndentStreamControl pout) throws IOException {
		
		String param = parameters[0].getName();

		String[] indices = getIndexParamNames();
		if (!isElementAccess()) super.writeArrayAssertion(pout, param, indices);
		
		super.writeArrayAccess(pout, Access.WRITE, param, indices);
		
	}

}
