package org.cakelab.nio.generator.codegen.struct;

import org.cakelab.codegen.ClassGen;
import org.cakelab.codegen.VariableGen;
import org.cakelab.nio.meta.FieldMeta;

public abstract class FieldMethodGen extends ViewClassMethodGen {

	/**
	 * Defines the type of access to be performed on a field (get/set)
	 * @author homac
	 */
	public static enum Access {
		READ,
		WRITE;

		public String getEquivalentBufferMethod() {
			if (this == READ) return "get";
			else return "put";
		}
		public String getEquivalentViewMethod() {
			if (this == READ) return "get";
			else return "set";
		}
	}

	protected String attrName;
	private int attrOffset;
	protected Class<?> attrType;
	protected FieldMeta fieldMeta;

	public FieldMethodGen(ClassGen classgen, FieldMeta fieldMeta, Class<?> type, String name, VariableGen ... parameters) {
		this(classgen, fieldMeta, type.getCanonicalName(), name, parameters);
	}

	public FieldMethodGen(ClassGen classgen, FieldMeta fieldMeta, String typeName, String name, VariableGen ... parameters) {
		super(classgen, "public", typeName, name, parameters);
		this.fieldMeta = fieldMeta;
		
		this.attrName = fieldMeta.name;
		this.attrType = fieldMeta.getType();
		this.attrOffset = fieldMeta.offset;
	}

	public int getSortPosition() {
		return attrOffset+100;
	}
}
