package org.cakelab.nio.generator.codegen.struct;

import java.io.IOException;

import org.cakelab.codegen.ClassGen;
import org.cakelab.codegen.IndentStreamControl;
import org.cakelab.codegen.VariableGen;
import org.cakelab.nio.generator.codegen.Utils;
import org.cakelab.nio.meta.FieldMeta;
import org.cakelab.nio.meta.TypeMeta.Kind;

public class ScalarFieldGetterMethodGen extends FieldMethodGen {

	public ScalarFieldGetterMethodGen(ClassGen classgen, FieldMeta fieldMeta, VariableGen ... parameters) {
		super(classgen, fieldMeta, fieldMeta.getType(), "get" + Utils.toCamelCase(fieldMeta.name), parameters);
		if (fieldMeta.getKind() != Kind.Scalar) throw new Error("for scalar attributes only");
	}
	
	@Override
	public void writeMethodBody(IndentStreamControl pout) throws IOException {

		pout.println("return " + generateFieldGetter(fieldMeta) + ";");
		
	}
}
