package org.cakelab.nio.generator.codegen.struct;

import java.io.IOException;

import org.cakelab.codegen.ClassGen;
import org.cakelab.codegen.IndentStreamControl;
import org.cakelab.codegen.VariableGen;
import org.cakelab.nio.generator.codegen.Utils;
import org.cakelab.nio.meta.FieldMeta;
import org.cakelab.nio.meta.TypeMeta.Kind;

public class ScalarFieldSetterMethodGen extends FieldMethodGen {


	public ScalarFieldSetterMethodGen(ClassGen classgen, FieldMeta fieldMeta) {
		super(classgen, fieldMeta, void.class, "set" + Utils.toCamelCase(fieldMeta.name), new VariableGen(fieldMeta.getType().getCanonicalName(), fieldMeta.name));
		if (fieldMeta.getKind() != Kind.Scalar) throw new Error("method does not refer to a scalar attribute");
	}

	@Override
	public void writeMethodBody(IndentStreamControl pout) throws IOException {
		pout.println(generateFieldSetter(fieldMeta, parameters[0].getName()) + ";");
	}

}
