package org.cakelab.nio.generator.codegen.struct;

import java.io.IOException;

import org.cakelab.codegen.ClassGen;
import org.cakelab.codegen.IndentStreamControl;
import org.cakelab.codegen.VariableGen;
import org.cakelab.nio.generator.codegen.Utils;
import org.cakelab.nio.meta.FieldMeta;

public class StructFieldGetterMethodGen extends StructFieldMethodGen {

	public StructFieldGetterMethodGen(ClassGen classgen, FieldMeta fieldMeta, VariableGen ... parameters) {
		super(classgen, fieldMeta, fieldMeta.getType(), "get" + Utils.toCamelCase(fieldMeta.name), parameters);
	}
	
	@Override
	public void writeMethodBody(IndentStreamControl pout) throws IOException {
		
		if (hasParameters()) {
			if (!fieldMeta.isReusable()) throw new Error("internal error: field " + fieldMeta.name + " is non-reusable");
			pout.println("return " + "this." + fieldMeta.name + ".get(" + parameters[0].getName() + ");");
		} else {
			if (fieldMeta.isReusable()) {
				pout.println("return " + this.name + "(" + Utils.generateInitialiser(fieldMeta) + ");");
			} else {
				pout.println("return " + "this." + fieldMeta.name + ".get();");
			}
		}

	}



}
