package org.cakelab.nio.generator.codegen.struct;

import java.io.IOException;

import org.cakelab.codegen.ClassGen;
import org.cakelab.codegen.IndentStreamControl;
import org.cakelab.codegen.VariableGen;
import org.cakelab.nio.generator.codegen.Utils;
import org.cakelab.nio.meta.FieldMeta;

public class StructFieldViewMethodGen extends StructFieldMethodGen {

	public StructFieldViewMethodGen(ClassGen classgen, String viewTypeName, FieldMeta fieldMeta, VariableGen ... parameters) {
		super(classgen, fieldMeta, viewTypeName, "view" + Utils.toCamelCase(fieldMeta.name), parameters);
	}
	
	@Override
	public void writeMethodBody(IndentStreamControl pout) throws IOException {
		if (this.parameters.length == 0) {
			pout.println("return this." + fieldMeta.name + ";");
		} else {
			pout.println("return this." + fieldMeta.name + ".clone(" + parameters[0].getName() +");");
		}
	}



}
