package org.cakelab.nio.generator.codegen.struct;

import java.io.IOException;

import org.cakelab.codegen.ClassGen;
import org.cakelab.codegen.IndentStreamControl;
import org.cakelab.codegen.VariableGen;
import org.cakelab.nio.generator.codegen.FactoryMethodGen;
import org.cakelab.nio.meta.FieldMeta;
import org.cakelab.nio.meta.TypeMeta;

/**
 * Generator for method <code>T get(T result);</code>
 * @author homac
 *
 */
public class StructGetterMethodGen extends ViewClassMethodGen {

	private TypeMeta typeMeta;

	public StructGetterMethodGen(ClassGen classgen, int offset, TypeMeta typeMeta, VariableGen parameter) {
		super(classgen, "public", typeMeta.type, "get", parameter);
		this.typeMeta = typeMeta;
	}

	public StructGetterMethodGen(ClassGen classgen, int offset, TypeMeta typeMeta) {
		super(classgen, "public", typeMeta.type, "get");
		this.typeMeta = typeMeta;
	}

	@Override
	public void writeMethodBody(IndentStreamControl pout) throws IOException {

		if (hasParameters()) {
			String resultVar = parameters[0].getName();
			for (FieldMeta fm : typeMeta.fields) {
				String fieldVar = resultVar + "." + fm.name;
				pout.println(generateFieldGetter(fm, fieldVar) + ";");
			}
			pout.println("return " + resultVar + ";");
		} else {
			pout.println("return get(" + "this." + FactoryMethodGen.METHOD_NAME + "()" + ");");
		}
		
	}

	@Override
	public int getSortPosition() {
		return 5;
	}

	

}
