package org.cakelab.nio.generator.codegen.struct;

import java.io.IOException;

import org.cakelab.codegen.ClassGen;
import org.cakelab.codegen.IndentStreamControl;
import org.cakelab.codegen.VariableGen;
import org.cakelab.nio.meta.FieldMeta;
import org.cakelab.nio.meta.TypeMeta;

/**
 * Generator for method <code>T get(T result);</code>
 * @author homac
 *
 */
public class StructSetterMethodGen extends ViewClassMethodGen {


	private TypeMeta typeMeta;

	public StructSetterMethodGen(ClassGen classgen, int offset, TypeMeta typeMeta) {
		super(classgen, "public", void.class, "set", new VariableGen(typeMeta.type.getCanonicalName(), "value"));
		this.typeMeta = typeMeta;
	}

	@Override
	public void writeMethodBody(IndentStreamControl pout) throws IOException {
		
		for (FieldMeta fm : typeMeta.fields) {
			pout.println(generateFieldSetter(fm, parameters[0].getName() + "." + fm.name) + ";");
		}
		
	}

	@Override
	public int getSortPosition() {
		return 5;
	}


}
