package org.cakelab.nio.meta;

/**
 * A type proxy is inserted in the metdata cache,
 * when a field with user defined view is parsed. 
 * 
 * It is properly analysed in regards to its view, 
 * but there will be no user feedback such as on 
 * hidden fields for generated views.
 * 
 * The type proxy acts as a proxy for the actual 
 * metadata until the same type is used without 
 * a user defined view. This also applies to all
 * types referenced by the type unless they 
 * already exist in the cache.
 * 
 * @author homac
 *
 */
public class TypeProxy extends TypeMeta {

	public TypeProxy(Class<?> type) {
		super(type, false);
	}

}
