package org.cakelab.nio.view;
/**
 * 
 * @author homac
 *
 * @param <A> Array type such as int[] or MyStruct[][] etc. .
 */
public interface ArrayView<A> extends ReusableDataView<A> {
	/** 
	 * This method calculates the distance between the start of one component 
	 * and the next component of this array. If components are aligned, then 
	 * the stride can be larger then the size of the components, since the next
	 * component might have to be aligned to a higher address.
	 * The result of this method is the same as calling:
	 * <pre>
	 * componentView.stride()
	 * </pre>
	 * @return distance between two array components considering size and alignment.
	 * @see DataView#stride()
	 */
	public int componentStride();
	
	/**
	 * @return length of the array (i.e. number of components)
	 */
	public int length();
	
}
