package org.cakelab.nio.view;

/** 
 * Base interface for all kinds of data views on compound (class or array) types.
 * 
 * @see ReusableDataView
 * 
 * @author homac
 *
 */
public interface GenericDataView<T> extends DataView {
	GenericDataView<T> clone();
	
	/** Read data into a <b>new</b> Java object of type T. */
	T get();
	/** Write data to buffer from given Java object v. */
	void set(T v);
	/** returns associated Java type of this view. */
	Class<T> javatype();
	
}
