package org.cakelab.nio.view.array;

import org.cakelab.nio.view.ArrayView;
import org.cakelab.nio.view.array.impl.booleanArrayViewStandard;
import org.cakelab.nio.view.array.impl.booleanArrayViewUser;
import org.cakelab.nio.view.scalar.booleanView;

public interface booleanArrayView extends ArrayView<boolean[]> {
	
	static final int STANDARD_ELEM_SIZE = Byte.BYTES;
	
	static booleanArrayViewStandard create(int length) {
		return create((short)1, length);
	}
	
	static booleanArrayViewStandard create(short alignment, int length) {
		return new booleanArrayViewStandard(alignment, length);
	}
	
	static <EV extends booleanView> booleanArrayViewUser<EV> create(EV elemView, int length0) {
		return new booleanArrayViewUser<EV>(elemView, length0);
	}
	
	
	
	boolean get(int index);
	void set(boolean value, int index);

	booleanArrayView clone();
	booleanArrayView clone(booleanArrayView view);


}
