package org.cakelab.nio.view.array;

import org.cakelab.nio.view.ArrayView;
import org.cakelab.nio.view.array.impl.byteArrayViewPacked;
import org.cakelab.nio.view.array.impl.byteArrayViewSpaced;
import org.cakelab.nio.view.array.impl.byteArrayViewUser;
import org.cakelab.nio.view.scalar.byteView;

public interface byteArrayView extends ArrayView<byte[]> {
	static int STANDARD_ELEM_SIZE = Byte.BYTES;
	
	static byteArrayViewPacked create(int length) {
		return new byteArrayViewPacked(length);
	}
	static byteArrayView create(short alignment, int length) {
		if (alignment > 1) return new byteArrayViewSpaced(alignment, length);
		else return create(length);
	}
	static <EV extends byteView> byteArrayViewUser<EV> create(EV elemView, int length) {
		return new byteArrayViewUser<EV>(elemView, length);
	}
	
	
	byte get(int index);
	void set(byte value, int index);

	byteArrayView clone();
	byteArrayView clone(byteArrayView view);

}
