package org.cakelab.nio.view.array;

import org.cakelab.nio.view.ArrayView;
import org.cakelab.nio.view.array.impl.charArrayViewPacked;
import org.cakelab.nio.view.array.impl.charArrayViewSpaced;
import org.cakelab.nio.view.array.impl.charArrayViewUser;
import org.cakelab.nio.view.scalar.charView;

public interface charArrayView extends ArrayView<char[]> {
	
	static final int STANDARD_ELEM_SIZE = Character.BYTES;
	
	public static charArrayViewPacked create(int length) {
		return new charArrayViewPacked(length);
	}
	public static charArrayView create(short alignment, int length) {
		if (alignment > 1) return new charArrayViewSpaced(alignment, length);
		else return create(length);
	}
	public static <EV extends charView> charArrayViewUser<EV> create(EV elemView, int length) {
		return new charArrayViewUser<EV>(elemView, length);
	}
	
	
	char get(int index);
	void set(char value, int index);

	charArrayView clone();
	charArrayView clone(charArrayView view);

}
