package org.cakelab.nio.view.array;

import org.cakelab.nio.view.ArrayView;
import org.cakelab.nio.view.array.impl.doubleArrayViewPacked;
import org.cakelab.nio.view.array.impl.doubleArrayViewSpaced;
import org.cakelab.nio.view.array.impl.doubleArrayViewUser;
import org.cakelab.nio.view.scalar.doubleView;

public interface doubleArrayView extends ArrayView<double[]> {
	
	static final int STANDARD_ELEM_SIZE = Double.BYTES;
	
	public static doubleArrayViewPacked create(int length) {
		return new doubleArrayViewPacked(length);
	}
	public static doubleArrayView create(short alignment, int length) {
		if (alignment > 1) return new doubleArrayViewSpaced(alignment, length);
		else return create(length);
	}
	public static <EV extends doubleView> doubleArrayViewUser<EV> create(EV elemView, int length) {
		return new doubleArrayViewUser<EV>(elemView, length);
	}
	
	
	double get(int index);
	void set(double value, int index);

	doubleArrayView clone();
	doubleArrayView clone(doubleArrayView view);

}
