package org.cakelab.nio.view.array;

import org.cakelab.nio.view.ArrayView;
import org.cakelab.nio.view.array.impl.floatArrayViewPacked;
import org.cakelab.nio.view.array.impl.floatArrayViewSpaced;
import org.cakelab.nio.view.array.impl.floatArrayViewUser;
import org.cakelab.nio.view.scalar.floatView;

public interface floatArrayView extends ArrayView<float[]> {
	
	static final int STANDARD_ELEM_SIZE = Float.BYTES;
	
	public static floatArrayViewPacked create(int length) {
		return new floatArrayViewPacked(length);
	}
	public static floatArrayView create(short alignment, int length) {
		if (alignment > 1) return new floatArrayViewSpaced(alignment, length);
		else return create(length);
	}
	public static <EV extends floatView> floatArrayViewUser<EV> create(EV elemView, int length) {
		return new floatArrayViewUser<EV>(elemView, length);
	}
	
	
	float get(int index);
	void set(float value, int index);

	floatArrayView clone();
	floatArrayView clone(floatArrayView view);

}
