package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.booleanArrayView;
import org.cakelab.nio.view.impl.ScalarArrayViewBase;
import org.cakelab.nio.view.scalar.booleanView;

public class booleanArrayViewStandard extends ScalarArrayViewBase<boolean[]> implements booleanArrayView {

	
	public booleanArrayViewStandard(short alignment, int length) {
		super(boolean[].class, alignment, STANDARD_ELEM_SIZE, length);
	}

	public booleanArrayViewStandard(booleanArrayViewStandard that) {
		super(that);
	}

	@Override
	protected int getElemSize() {
		return STANDARD_ELEM_SIZE;
	}
	
	@Override
	public boolean[] newDataInstance() {
		return new boolean[length];
	}
	
	public boolean get(int index) {
		return booleanView.toBoolean(__nio__buffer.get(getIndexedOffset(index)));
	}
	
	public void set(boolean value, int index) {
		__nio__buffer.put(getIndexedOffset(index), booleanView.toByte(value));
	}
	
	@Override
	protected boolean[] getArray(int offset, boolean[] result) {
		for (int i = 0; i < length; i++) {
			result[i] = booleanView.toBoolean(__nio__buffer.get(offset));
			offset += stride;
		}
		return result;
	}

	@Override
	protected void setArray(int offset, boolean[] result) {
		for (int i = 0; i < length; i++) {
			__nio__buffer.put(offset, booleanView.toByte(result[i]));
			offset += stride;
		}
	}

	@Override
	public booleanArrayViewStandard clone() {
		return super.clone(new booleanArrayViewStandard(alignment(), length));
	}

	@Override
	public booleanArrayView clone(booleanArrayView view) {
		assert (view instanceof booleanArrayViewStandard);
		return super.clone(view);
	}

	public booleanArrayViewStandard clone(booleanArrayViewStandard view) {
		return super.clone(view);
	}

	@Override
	public Class<boolean[]> javatype() {
		return boolean[].class;
	}


}
