package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.booleanArrayView;
import org.cakelab.nio.view.impl.ScalarViewArrayViewBase;
import org.cakelab.nio.view.scalar.booleanView;

public class booleanArrayViewUser<EV extends booleanView> extends ScalarViewArrayViewBase<boolean[], EV> implements booleanArrayView {

	public booleanArrayViewUser(EV elemView, int length) {
		super(boolean[].class, elemView, length);
	}

	public booleanArrayViewUser(booleanArrayViewUser<EV> that) {
		super(that);
	}

	@Override
	public booleanArrayViewUser<EV> clone() {
		return super.clone(new booleanArrayViewUser<EV>(this));
	}

	@SuppressWarnings("unchecked")
	@Override
	public booleanArrayView clone(booleanArrayView view) {
		assert (view instanceof booleanArrayViewUser);
		return super.clone((booleanArrayViewUser<EV>)view);
	}

	public booleanArrayViewUser<EV> clone(booleanArrayViewUser<EV> view) {
		return super.clone(view);
	}

	@Override
	public Class<boolean[]> javatype() {
		return boolean[].class;
	}

	@Override
	public boolean get(int index) {
		elemView.offset(getIndexedOffset(index));
		return elemView.get();
	}

	@Override
	public void set(boolean value, int index) {
		elemView.offset(getIndexedOffset(index));
		elemView.set(value);
	}
	
	@Override
	public boolean[] newDataInstance() {
		return new boolean[length];
	}

	@Override
	protected boolean[] getArray(int offset, boolean[] result) {
		for (int i = 0; i < length; i++) {
			elemView.offset(offset);
			result[i] = elemView.get();
			offset += stride;
		}
		return result;
	}

	@Override
	protected void setArray(int offset, boolean[] result) {
		for (int i = 0; i < length; i++) {
			elemView.offset(offset);
			elemView.set(result[i]);
			offset += stride;
		}
	}

}
