package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.byteArrayView;
import org.cakelab.nio.view.impl.ScalarArrayViewBase;

public class byteArrayViewPacked extends ScalarArrayViewBase<byte[]> implements byteArrayView {

	
	public byteArrayViewPacked(int length) {
		super(byte[].class, (short)1, STANDARD_ELEM_SIZE, length);
	}

	public byteArrayViewPacked(byteArrayViewPacked that) {
		super(that);
	}

	@Override
	protected int getElemSize() {
		return STANDARD_ELEM_SIZE;
	}
	
	@Override
	public byte[] newDataInstance() {
		return new byte[length];
	}
	
	public byte get(int index) {
		return __nio__buffer.get(getIndexedOffset(index));
	}
	
	public void set(byte value, int index) {
		__nio__buffer.put(getIndexedOffset(index), value);
	}
	
	@Override
	protected byte[] getArray(int offset, byte[] result) {
		__nio__buffer.position(offset);
		__nio__buffer.get(result);
		return result;
	}

	@Override
	protected void setArray(int offset, byte[] result) {
		__nio__buffer.position(offset);
		__nio__buffer.put(result);
	}

	@Override
	public byteArrayViewPacked clone() {
		return super.clone(new byteArrayViewPacked(length));
	}
	
	@Override
	public byteArrayView clone(byteArrayView view) {
		assert (view instanceof byteArrayViewPacked);
		return super.clone(view);
	}
	
	public byteArrayViewPacked clone(byteArrayViewPacked view) {
		return super.clone(view);
	}

	@Override
	public Class<byte[]> javatype() {
		return byte[].class;
	}


}
