package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.byteArrayView;
import org.cakelab.nio.view.impl.ScalarArrayViewBase;

public class byteArrayViewSpaced extends ScalarArrayViewBase<byte[]> implements byteArrayView {

	
	public byteArrayViewSpaced(short alignment, int length) {
		super(byte[].class, alignment, STANDARD_ELEM_SIZE, length);
	}

	public byteArrayViewSpaced(byteArrayViewSpaced that) {
		super(that);
	}

	@Override
	protected int getElemSize() {
		return STANDARD_ELEM_SIZE;
	}
	
	@Override
	public byte[] newDataInstance() {
		return new byte[length];
	}
	
	public byte get(int index) {
		return __nio__buffer.get(getIndexedOffset(index));
	}
	
	public void set(byte value, int index) {
		__nio__buffer.put(getIndexedOffset(index), value);
	}
	
	@Override
	protected byte[] getArray(int offset, byte[] result) {
		for (int i = 0; i < length; i++) {
			result[i] = __nio__buffer.get(offset);
			offset += stride;
		}
		return result;
	}

	@Override
	protected void setArray(int offset, byte[] result) {
		for (int i = 0; i < length; i++) {
			__nio__buffer.put(offset, result[i]);
			offset += stride;
		}
	}

	@Override
	public byteArrayViewSpaced clone() {
		return super.clone(new byteArrayViewSpaced(alignment(), length));
	}

	@Override
	public byteArrayView clone(byteArrayView view) {
		assert (view instanceof byteArrayViewSpaced);
		return super.clone(view);
	}

	public byteArrayViewSpaced clone(byteArrayViewSpaced view) {
		return super.clone(view);
	}

	@Override
	public Class<byte[]> javatype() {
		return byte[].class;
	}


}
