package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.byteArrayView;
import org.cakelab.nio.view.impl.ScalarViewArrayViewBase;
import org.cakelab.nio.view.scalar.byteView;

public class byteArrayViewUser<EV extends byteView> extends ScalarViewArrayViewBase<byte[], EV> implements byteArrayView {

	public byteArrayViewUser(EV elemView, int length) {
		super(byte[].class, elemView, length);
	}

	public byteArrayViewUser(byteArrayViewUser<EV> that) {
		super(that);
	}

	@Override
	public byteArrayViewUser<EV> clone() {
		return super.clone(new byteArrayViewUser<EV>(this));
	}

	@SuppressWarnings("unchecked")
	@Override
	public byteArrayView clone(byteArrayView view) {
		assert (view instanceof byteArrayViewUser);
		return super.clone((byteArrayViewUser<EV>)view);
	}

	public byteArrayViewUser<EV> clone(byteArrayViewUser<EV> view) {
		return super.clone(view);
	}

	@Override
	public Class<byte[]> javatype() {
		return byte[].class;
	}

	@Override
	public byte get(int index) {
		elemView.offset(getIndexedOffset(index));
		return elemView.get();
	}

	@Override
	public void set(byte value, int index) {
		elemView.offset(getIndexedOffset(index));
		elemView.set(value);
	}
	
	@Override
	public byte[] newDataInstance() {
		return new byte[length];
	}

	@Override
	protected byte[] getArray(int offset, byte[] result) {
		for (int i = 0; i < length; i++) {
			elemView.offset(offset);
			result[i] = elemView.get();
			offset += stride;
		}
		return result;
	}

	@Override
	protected void setArray(int offset, byte[] result) {
		for (int i = 0; i < length; i++) {
			elemView.offset(offset);
			elemView.set(result[i]);
			offset += stride;
		}
	}

}
