package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.charArrayView;
import org.cakelab.nio.view.impl.ScalarArrayViewBase;

public class charArrayViewPacked extends ScalarArrayViewBase<char[]> implements charArrayView {
	
	public charArrayViewPacked(int length) {
		super(char[].class, (short)1, STANDARD_ELEM_SIZE, length);
	}

	public charArrayViewPacked(charArrayViewPacked that) {
		super(that);
	}

	@Override
	protected int getElemSize() {
		return STANDARD_ELEM_SIZE;
	}
	
	@Override
	public char[] newDataInstance() {
		return new char[length];
	}
	
	public char get(int index) {
		return __nio__buffer.getChar(getIndexedOffset(index));
	}
	
	public void set(char value, int index) {
		__nio__buffer.putChar(getIndexedOffset(index), value);
	}
	
	@Override
	protected char[] getArray(int offset, char[] result) {
		__nio__buffer.position(offset);
		__nio__buffer.asCharBuffer().get(result);
		return result;
	}

	@Override
	protected void setArray(int offset, char[] result) {
		__nio__buffer.position(offset);
		__nio__buffer.asCharBuffer().put(result);
	}

	@Override
	public charArrayViewPacked clone() {
		return super.clone(new charArrayViewPacked(length));
	}
	
	@Override
	public charArrayView clone(charArrayView view) {
		assert (view instanceof charArrayViewPacked);
		return super.clone(view);
	}
	
	public charArrayViewPacked clone(charArrayViewPacked view) {
		return super.clone(view);
	}

	@Override
	public Class<char[]> javatype() {
		return char[].class;
	}


}
