package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.charArrayView;
import org.cakelab.nio.view.impl.ScalarArrayViewBase;

public class charArrayViewSpaced extends ScalarArrayViewBase<char[]> implements charArrayView {

	
	public charArrayViewSpaced(short alignment, int length) {
		super(char[].class, alignment, STANDARD_ELEM_SIZE, length);
	}

	public charArrayViewSpaced(charArrayViewSpaced that) {
		super(that);
	}

	@Override
	protected int getElemSize() {
		return STANDARD_ELEM_SIZE;
	}
	
	@Override
	public char[] newDataInstance() {
		return new char[length];
	}
	
	public char get(int index) {
		return __nio__buffer.getChar(getIndexedOffset(index));
	}
	
	public void set(char value, int index) {
		__nio__buffer.putChar(getIndexedOffset(index), value);
	}
	
	@Override
	protected char[] getArray(int offset, char[] result) {
		for (int i = 0; i < length; i++) {
			result[i] = __nio__buffer.getChar(offset);
			offset += stride;
		}
		return result;
	}

	@Override
	protected void setArray(int offset, char[] result) {
		for (int i = 0; i < length; i++) {
			__nio__buffer.putChar(offset, result[i]);
			offset += stride;
		}
	}

	@Override
	public charArrayViewSpaced clone() {
		return super.clone(new charArrayViewSpaced(alignment(), length));
	}

	@Override
	public charArrayView clone(charArrayView view) {
		assert (view instanceof charArrayViewSpaced);
		return super.clone(view);
	}

	public charArrayViewSpaced clone(charArrayViewSpaced view) {
		return super.clone(view);
	}

	@Override
	public Class<char[]> javatype() {
		return char[].class;
	}


}
