package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.charArrayView;
import org.cakelab.nio.view.impl.ScalarViewArrayViewBase;
import org.cakelab.nio.view.scalar.charView;

public class charArrayViewUser<EV extends charView> extends ScalarViewArrayViewBase<char[], EV> implements charArrayView {

	public charArrayViewUser(EV elemView, int length) {
		super(char[].class, elemView, length);
	}

	public charArrayViewUser(charArrayViewUser<EV> that) {
		super(that);
	}

	@Override
	public charArrayViewUser<EV> clone() {
		return super.clone(new charArrayViewUser<EV>(this));
	}

	@SuppressWarnings("unchecked")
	@Override
	public charArrayView clone(charArrayView view) {
		assert (view instanceof charArrayViewUser);
		return super.clone((charArrayViewUser<EV>)view);
	}

	public charArrayViewUser<EV> clone(charArrayViewUser<EV> view) {
		return super.clone(view);
	}

	@Override
	public Class<char[]> javatype() {
		return char[].class;
	}

	@Override
	public char get(int index) {
		elemView.offset(getIndexedOffset(index));
		return elemView.get();
	}

	@Override
	public void set(char value, int index) {
		elemView.offset(getIndexedOffset(index));
		elemView.set(value);
	}
	
	@Override
	public char[] newDataInstance() {
		return new char[length];
	}

	@Override
	protected char[] getArray(int offset, char[] result) {
		for (int i = 0; i < length; i++) {
			elemView.offset(offset);
			result[i] = elemView.get();
			offset += stride;
		}
		return result;
	}

	@Override
	protected void setArray(int offset, char[] result) {
		for (int i = 0; i < length; i++) {
			elemView.offset(offset);
			elemView.set(result[i]);
			offset += stride;
		}
	}

}
