package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.doubleArrayView;
import org.cakelab.nio.view.impl.ScalarArrayViewBase;

public class doubleArrayViewPacked extends ScalarArrayViewBase<double[]> implements doubleArrayView {

	
	public doubleArrayViewPacked(int length) {
		super(double[].class, (short)1, STANDARD_ELEM_SIZE, length);
	}

	public doubleArrayViewPacked(doubleArrayViewPacked that) {
		super(that);
	}

	@Override
	protected int getElemSize() {
		return STANDARD_ELEM_SIZE;
	}
	
	@Override
	public double[] newDataInstance() {
		return new double[length];
	}
	
	public double get(int index) {
		return __nio__buffer.getDouble(getIndexedOffset(index));
	}
	
	public void set(double value, int index) {
		__nio__buffer.putDouble(getIndexedOffset(index), value);
	}
	
	@Override
	protected double[] getArray(int offset, double[] result) {
		__nio__buffer.position(offset);
		__nio__buffer.asDoubleBuffer().get(result);
		return result;
	}

	@Override
	protected void setArray(int offset, double[] result) {
		__nio__buffer.position(offset);
		__nio__buffer.asDoubleBuffer().put(result);
	}

	@Override
	public doubleArrayViewPacked clone() {
		return super.clone(new doubleArrayViewPacked(length));
	}
	
	@Override
	public doubleArrayView clone(doubleArrayView view) {
		assert (view instanceof doubleArrayViewPacked);
		return super.clone(view);
	}
	
	public doubleArrayViewPacked clone(doubleArrayViewPacked view) {
		return super.clone(view);
	}

	@Override
	public Class<double[]> javatype() {
		return double[].class;
	}


}
