package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.doubleArrayView;
import org.cakelab.nio.view.impl.ScalarArrayViewBase;

public class doubleArrayViewSpaced extends ScalarArrayViewBase<double[]> implements doubleArrayView {

	
	public doubleArrayViewSpaced(short alignment, int length) {
		super(double[].class, alignment, STANDARD_ELEM_SIZE, length);
	}

	public doubleArrayViewSpaced(doubleArrayViewSpaced that) {
		super(that);
	}

	@Override
	protected int getElemSize() {
		return STANDARD_ELEM_SIZE;
	}
	
	@Override
	public double[] newDataInstance() {
		return new double[length];
	}
	
	public double get(int index) {
		return __nio__buffer.getDouble(getIndexedOffset(index));
	}
	
	public void set(double value, int index) {
		__nio__buffer.putDouble(getIndexedOffset(index), value);
	}
	
	@Override
	protected double[] getArray(int offset, double[] result) {
		for (int i = 0; i < length; i++) {
			result[i] = __nio__buffer.getDouble(offset);
			offset += stride;
		}
		return result;
	}

	@Override
	protected void setArray(int offset, double[] result) {
		for (int i = 0; i < length; i++) {
			__nio__buffer.putDouble(offset, result[i]);
			offset += stride;
		}
	}

	@Override
	public doubleArrayViewSpaced clone() {
		return super.clone(new doubleArrayViewSpaced(alignment(), length));
	}

	@Override
	public doubleArrayView clone(doubleArrayView view) {
		assert (view instanceof doubleArrayViewSpaced);
		return super.clone(view);
	}

	public doubleArrayViewSpaced clone(doubleArrayViewSpaced view) {
		return super.clone(view);
	}

	@Override
	public Class<double[]> javatype() {
		return double[].class;
	}


}
