package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.doubleArrayView;
import org.cakelab.nio.view.impl.ScalarViewArrayViewBase;
import org.cakelab.nio.view.scalar.doubleView;

public class doubleArrayViewUser<EV extends doubleView> extends ScalarViewArrayViewBase<double[], EV> implements doubleArrayView {

	public doubleArrayViewUser(EV elemView, int length) {
		super(double[].class, elemView, length);
	}

	public doubleArrayViewUser(doubleArrayViewUser<EV> that) {
		super(that);
	}

	@Override
	public doubleArrayViewUser<EV> clone() {
		return super.clone(new doubleArrayViewUser<EV>(this));
	}

	@SuppressWarnings("unchecked")
	@Override
	public doubleArrayView clone(doubleArrayView view) {
		assert (view instanceof doubleArrayViewUser);
		return super.clone((doubleArrayViewUser<EV>)view);
	}

	public doubleArrayViewUser<EV> clone(doubleArrayViewUser<EV> view) {
		return super.clone(view);
	}

	@Override
	public Class<double[]> javatype() {
		return double[].class;
	}

	@Override
	public double get(int index) {
		elemView.offset(getIndexedOffset(index));
		return elemView.get();
	}

	@Override
	public void set(double value, int index) {
		elemView.offset(getIndexedOffset(index));
		elemView.set(value);
	}
	
	@Override
	public double[] newDataInstance() {
		return new double[length];
	}

	@Override
	protected double[] getArray(int offset, double[] result) {
		for (int i = 0; i < length; i++) {
			elemView.offset(offset);
			result[i] = elemView.get();
			offset += stride;
		}
		return result;
	}

	@Override
	protected void setArray(int offset, double[] result) {
		for (int i = 0; i < length; i++) {
			elemView.offset(offset);
			elemView.set(result[i]);
			offset += stride;
		}
	}

}
