package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.floatArrayView;
import org.cakelab.nio.view.impl.ScalarArrayViewBase;

public class floatArrayViewPacked extends ScalarArrayViewBase<float[]> implements floatArrayView {

	
	public floatArrayViewPacked(int length) {
		super(float[].class, (short)1, STANDARD_ELEM_SIZE, length);
	}

	public floatArrayViewPacked(floatArrayViewPacked that) {
		super(that);
	}

	@Override
	protected int getElemSize() {
		return STANDARD_ELEM_SIZE;
	}
	
	@Override
	public float[] newDataInstance() {
		return new float[length];
	}
	
	public float get(int index) {
		return __nio__buffer.getFloat(getIndexedOffset(index));
	}
	
	public void set(float value, int index) {
		__nio__buffer.putFloat(getIndexedOffset(index), value);
	}
	
	@Override
	protected float[] getArray(int offset, float[] result) {
		__nio__buffer.position(offset);
		__nio__buffer.asFloatBuffer().get(result);
		return result;
	}

	@Override
	protected void setArray(int offset, float[] result) {
		__nio__buffer.position(offset);
		__nio__buffer.asFloatBuffer().put(result);
	}

	@Override
	public floatArrayViewPacked clone() {
		return super.clone(new floatArrayViewPacked(length));
	}
	
	@Override
	public floatArrayView clone(floatArrayView view) {
		assert (view instanceof floatArrayViewPacked);
		return super.clone(view);
	}
	
	public floatArrayViewPacked clone(floatArrayViewPacked view) {
		return super.clone(view);
	}

	@Override
	public Class<float[]> javatype() {
		return float[].class;
	}


}
