package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.floatArrayView;
import org.cakelab.nio.view.impl.ScalarArrayViewBase;

public class floatArrayViewSpaced extends ScalarArrayViewBase<float[]> implements floatArrayView {

	
	public floatArrayViewSpaced(short alignment, int length) {
		super(float[].class, alignment, STANDARD_ELEM_SIZE, length);
	}

	public floatArrayViewSpaced(floatArrayViewSpaced that) {
		super(that);
	}

	@Override
	protected int getElemSize() {
		return STANDARD_ELEM_SIZE;
	}
	
	@Override
	public float[] newDataInstance() {
		return new float[length];
	}
	
	public float get(int index) {
		return __nio__buffer.getFloat(getIndexedOffset(index));
	}
	
	public void set(float value, int index) {
		__nio__buffer.putFloat(getIndexedOffset(index), value);
	}
	
	@Override
	protected float[] getArray(int offset, float[] result) {
		for (int i = 0; i < length; i++) {
			result[i] = __nio__buffer.getFloat(offset);
			offset += stride;
		}
		return result;
	}

	@Override
	protected void setArray(int offset, float[] result) {
		for (int i = 0; i < length; i++) {
			__nio__buffer.putFloat(offset, result[i]);
			offset += stride;
		}
	}

	@Override
	public floatArrayViewSpaced clone() {
		return super.clone(new floatArrayViewSpaced(alignment(), length));
	}

	@Override
	public floatArrayView clone(floatArrayView view) {
		assert (view instanceof floatArrayViewSpaced);
		return super.clone(view);
	}

	public floatArrayViewSpaced clone(floatArrayViewSpaced view) {
		return super.clone(view);
	}

	@Override
	public Class<float[]> javatype() {
		return float[].class;
	}


}
