package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.floatArrayView;
import org.cakelab.nio.view.impl.ScalarViewArrayViewBase;
import org.cakelab.nio.view.scalar.floatView;

public class floatArrayViewUser<EV extends floatView> extends ScalarViewArrayViewBase<float[], EV> implements floatArrayView {

	public floatArrayViewUser(EV elemView, int length) {
		super(float[].class, elemView, length);
	}

	public floatArrayViewUser(floatArrayViewUser<EV> that) {
		super(that);
	}

	@Override
	public floatArrayViewUser<EV> clone() {
		return super.clone(new floatArrayViewUser<EV>(this));
	}

	@SuppressWarnings("unchecked")
	@Override
	public floatArrayView clone(floatArrayView view) {
		assert (view instanceof floatArrayViewUser);
		return super.clone((floatArrayViewUser<EV>)view);
	}

	public floatArrayViewUser<EV> clone(floatArrayViewUser<EV> view) {
		return super.clone(view);
	}

	@Override
	public Class<float[]> javatype() {
		return float[].class;
	}

	@Override
	public float get(int index) {
		elemView.offset(getIndexedOffset(index));
		return elemView.get();
	}

	@Override
	public void set(float value, int index) {
		elemView.offset(getIndexedOffset(index));
		elemView.set(value);
	}
	
	@Override
	public float[] newDataInstance() {
		return new float[length];
	}

	@Override
	protected float[] getArray(int offset, float[] result) {
		for (int i = 0; i < length; i++) {
			elemView.offset(offset);
			result[i] = elemView.get();
			offset += stride;
		}
		return result;
	}

	@Override
	protected void setArray(int offset, float[] result) {
		for (int i = 0; i < length; i++) {
			elemView.offset(offset);
			elemView.set(result[i]);
			offset += stride;
		}
	}

}
