package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.intArrayView;
import org.cakelab.nio.view.impl.ScalarArrayViewBase;

public class intArrayViewPacked extends ScalarArrayViewBase<int[]> implements intArrayView {

	
	public intArrayViewPacked(int length) {
		super(int[].class, (short)1, STANDARD_ELEM_SIZE, length);
	}

	public intArrayViewPacked(intArrayViewPacked that) {
		super(that);
	}

	@Override
	protected int getElemSize() {
		return STANDARD_ELEM_SIZE;
	}
	
	@Override
	public int[] newDataInstance() {
		return new int[length];
	}
	
	public int get(int index) {
		return __nio__buffer.getInt(getIndexedOffset(index));
	}
	
	public void set(int value, int index) {
		__nio__buffer.putInt(getIndexedOffset(index), value);
	}
	
	@Override
	protected int[] getArray(int offset, int[] result) {
		__nio__buffer.position(offset);
		__nio__buffer.asIntBuffer().get(result);
		return result;
	}

	@Override
	protected void setArray(int offset, int[] result) {
		__nio__buffer.position(offset);
		__nio__buffer.asIntBuffer().put(result);
	}

	@Override
	public intArrayViewPacked clone() {
		return super.clone(new intArrayViewPacked(length));
	}
	
	@Override
	public intArrayView clone(intArrayView view) {
		assert (view instanceof intArrayViewPacked);
		return super.clone(view);
	}
	
	public intArrayViewPacked clone(intArrayViewPacked view) {
		return super.clone(view);
	}

	@Override
	public Class<int[]> javatype() {
		return int[].class;
	}


}
