package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.ArrayView;
import org.cakelab.nio.view.array.intArrayView;
import org.cakelab.nio.view.impl.ScalarArrayViewBase;

public class intArrayViewSpaced extends ScalarArrayViewBase<int[]> implements ArrayView<int[]>, intArrayView {

	
	public intArrayViewSpaced(short alignment, int length) {
		super(int[].class, alignment, STANDARD_ELEM_SIZE, length);
	}

	public intArrayViewSpaced(intArrayViewSpaced that) {
		super(that);
	}

	@Override
	protected int getElemSize() {
		return STANDARD_ELEM_SIZE;
	}
	
	@Override
	public int[] newDataInstance() {
		return new int[length];
	}
	
	public int get(int index) {
		return __nio__buffer.getInt(getIndexedOffset(index));
	}
	
	public void set(int value, int index) {
		__nio__buffer.putInt(getIndexedOffset(index), value);
	}
	
	@Override
	protected int[] getArray(int offset, int[] result) {
		for (int i = 0; i < length; i++) {
			result[i] = __nio__buffer.getInt(offset);
			offset += stride;
		}
		return result;
	}

	@Override
	protected void setArray(int offset, int[] result) {
		for (int i = 0; i < length; i++) {
			__nio__buffer.putInt(offset, result[i]);
			offset += stride;
		}
	}

	@Override
	public intArrayViewSpaced clone() {
		return super.clone(new intArrayViewSpaced(alignment(), length));
	}

	@Override
	public intArrayView clone(intArrayView view) {
		assert (view instanceof intArrayViewSpaced);
		return super.clone(view);
	}

	public intArrayViewSpaced clone(intArrayViewSpaced view) {
		return super.clone(view);
	}

	@Override
	public Class<int[]> javatype() {
		return int[].class;
	}


}
