package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.intArrayView;
import org.cakelab.nio.view.impl.ScalarViewArrayViewBase;
import org.cakelab.nio.view.scalar.intView;

public class intArrayViewUser<EV extends intView> extends ScalarViewArrayViewBase<int[], EV> implements intArrayView {

	public intArrayViewUser(EV elemView, int length) {
		super(int[].class, elemView, length);
	}

	public intArrayViewUser(intArrayViewUser<EV> that) {
		super(that);
	}

	@Override
	public intArrayViewUser<EV> clone() {
		return super.clone(new intArrayViewUser<EV>(this));
	}

	@SuppressWarnings("unchecked")
	@Override
	public intArrayView clone(intArrayView view) {
		assert (view instanceof intArrayViewUser);
		return super.clone((intArrayViewUser<EV>)view);
	}

	public intArrayViewUser<EV> clone(intArrayViewUser<EV> view) {
		return super.clone(view);
	}

	@Override
	public Class<int[]> javatype() {
		return int[].class;
	}

	@Override
	public int get(int index) {
		elemView.offset(getIndexedOffset(index));
		return elemView.get();
	}

	@Override
	public void set(int value, int index) {
		elemView.offset(getIndexedOffset(index));
		elemView.set(value);
	}
	
	@Override
	public int[] newDataInstance() {
		return new int[length];
	}

	@Override
	protected int[] getArray(int offset, int[] result) {
		for (int i = 0; i < length; i++) {
			elemView.offset(offset);
			result[i] = elemView.get();
			offset += stride;
		}
		return result;
	}

	@Override
	protected void setArray(int offset, int[] result) {
		for (int i = 0; i < length; i++) {
			elemView.offset(offset);
			elemView.set(result[i]);
			offset += stride;
		}
	}

}
