package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.longArrayView;
import org.cakelab.nio.view.impl.ScalarArrayViewBase;

public class longArrayViewPacked extends ScalarArrayViewBase<long[]> implements longArrayView {

	
	public longArrayViewPacked(int length) {
		super(long[].class, (short)1, STANDARD_ELEM_SIZE, length);
	}

	public longArrayViewPacked(longArrayViewPacked that) {
		super(that);
	}

	@Override
	protected int getElemSize() {
		return STANDARD_ELEM_SIZE;
	}
	
	@Override
	public long[] newDataInstance() {
		return new long[length];
	}
	
	public long get(int index) {
		return __nio__buffer.getLong(getIndexedOffset(index));
	}
	
	public void set(long value, int index) {
		__nio__buffer.putLong(getIndexedOffset(index), value);
	}
	
	@Override
	protected long[] getArray(int offset, long[] result) {
		__nio__buffer.position(offset);
		__nio__buffer.asLongBuffer().get(result);
		return result;
	}

	@Override
	protected void setArray(int offset, long[] result) {
		__nio__buffer.position(offset);
		__nio__buffer.asLongBuffer().put(result);
	}

	@Override
	public longArrayViewPacked clone() {
		return super.clone(new longArrayViewPacked(length));
	}
	
	@Override
	public longArrayView clone(longArrayView view) {
		assert (view instanceof longArrayViewPacked);
		return super.clone(view);
	}
	
	public longArrayViewPacked clone(longArrayViewPacked view) {
		return super.clone(view);
	}

	@Override
	public Class<long[]> javatype() {
		return long[].class;
	}


}
