package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.longArrayView;
import org.cakelab.nio.view.impl.ScalarArrayViewBase;

public class longArrayViewSpaced extends ScalarArrayViewBase<long[]> implements longArrayView {

	
	public longArrayViewSpaced(short alignment, int length) {
		super(long[].class, alignment, STANDARD_ELEM_SIZE, length);
	}

	public longArrayViewSpaced(longArrayViewSpaced that) {
		super(that);
	}

	@Override
	protected int getElemSize() {
		return STANDARD_ELEM_SIZE;
	}
	
	@Override
	public long[] newDataInstance() {
		return new long[length];
	}
	
	public long get(int index) {
		return __nio__buffer.getLong(getIndexedOffset(index));
	}
	
	public void set(long value, int index) {
		__nio__buffer.putLong(getIndexedOffset(index), value);
	}
	
	@Override
	protected long[] getArray(int offset, long[] result) {
		for (int i = 0; i < length; i++) {
			result[i] = __nio__buffer.getLong(offset);
			offset += stride;
		}
		return result;
	}

	@Override
	protected void setArray(int offset, long[] result) {
		for (int i = 0; i < length; i++) {
			__nio__buffer.putLong(offset, result[i]);
			offset += stride;
		}
	}

	@Override
	public longArrayViewSpaced clone() {
		return super.clone(new longArrayViewSpaced(alignment(), length));
	}

	@Override
	public longArrayView clone(longArrayView view) {
		assert (view instanceof longArrayViewSpaced);
		return super.clone(view);
	}

	public longArrayViewSpaced clone(longArrayViewSpaced view) {
		return super.clone(view);
	}

	@Override
	public Class<long[]> javatype() {
		return long[].class;
	}


}
