package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.longArrayView;
import org.cakelab.nio.view.impl.ScalarViewArrayViewBase;
import org.cakelab.nio.view.scalar.longView;

public class longArrayViewUser<EV extends longView> extends ScalarViewArrayViewBase<long[], EV> implements longArrayView {

	public longArrayViewUser(EV elemView, int length) {
		super(long[].class, elemView, length);
	}

	public longArrayViewUser(longArrayViewUser<EV> that) {
		super(that);
	}

	@Override
	public longArrayViewUser<EV> clone() {
		return super.clone(new longArrayViewUser<EV>(this));
	}

	@SuppressWarnings("unchecked")
	@Override
	public longArrayView clone(longArrayView view) {
		assert (view instanceof longArrayViewUser);
		return super.clone((longArrayViewUser<EV>)view);
	}

	public longArrayViewUser<EV> clone(longArrayViewUser<EV> view) {
		return super.clone(view);
	}

	@Override
	public Class<long[]> javatype() {
		return long[].class;
	}

	@Override
	public long get(int index) {
		elemView.offset(getIndexedOffset(index));
		return elemView.get();
	}

	@Override
	public void set(long value, int index) {
		elemView.offset(getIndexedOffset(index));
		elemView.set(value);
	}
	
	@Override
	public long[] newDataInstance() {
		return new long[length];
	}

	@Override
	protected long[] getArray(int offset, long[] result) {
		for (int i = 0; i < length; i++) {
			elemView.offset(offset);
			result[i] = elemView.get();
			offset += stride;
		}
		return result;
	}

	@Override
	protected void setArray(int offset, long[] result) {
		for (int i = 0; i < length; i++) {
			elemView.offset(offset);
			elemView.set(result[i]);
			offset += stride;
		}
	}

}
