package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.shortArrayView;
import org.cakelab.nio.view.impl.ScalarArrayViewBase;

public class shortArrayViewPacked extends ScalarArrayViewBase<short[]> implements shortArrayView {

	
	public shortArrayViewPacked(int length) {
		super(short[].class, (short)1, STANDARD_ELEM_SIZE, length);
	}

	public shortArrayViewPacked(shortArrayViewPacked that) {
		super(that);
	}

	@Override
	protected int getElemSize() {
		return STANDARD_ELEM_SIZE;
	}
	
	@Override
	public short[] newDataInstance() {
		return new short[length];
	}
	
	public short get(int index) {
		return __nio__buffer.getShort(getIndexedOffset(index));
	}
	
	public void set(short value, int index) {
		__nio__buffer.putShort(getIndexedOffset(index), value);
	}
	
	@Override
	protected short[] getArray(int offset, short[] result) {
		__nio__buffer.position(offset);
		__nio__buffer.asShortBuffer().get(result);
		return result;
	}

	@Override
	protected void setArray(int offset, short[] result) {
		__nio__buffer.position(offset);
		__nio__buffer.asShortBuffer().put(result);
	}

	@Override
	public shortArrayViewPacked clone() {
		return super.clone(new shortArrayViewPacked(length));
	}
	
	@Override
	public shortArrayView clone(shortArrayView view) {
		assert (view instanceof shortArrayViewPacked);
		return super.clone(view);
	}
	
	public shortArrayViewPacked clone(shortArrayViewPacked view) {
		return super.clone(view);
	}

	@Override
	public Class<short[]> javatype() {
		return short[].class;
	}


}
