package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.shortArrayView;
import org.cakelab.nio.view.impl.ScalarArrayViewBase;

public class shortArrayViewSpaced extends ScalarArrayViewBase<short[]> implements shortArrayView {

	
	public shortArrayViewSpaced(short alignment, int length) {
		super(short[].class, alignment, STANDARD_ELEM_SIZE, length);
	}

	public shortArrayViewSpaced(shortArrayViewSpaced that) {
		super(that);
	}

	@Override
	protected int getElemSize() {
		return STANDARD_ELEM_SIZE;
	}
	
	@Override
	public short[] newDataInstance() {
		return new short[length];
	}
	
	public short get(int index) {
		return __nio__buffer.getShort(getIndexedOffset(index));
	}
	
	public void set(short value, int index) {
		__nio__buffer.putShort(getIndexedOffset(index), value);
	}
	
	@Override
	protected short[] getArray(int offset, short[] result) {
		for (int i = 0; i < length; i++) {
			result[i] = __nio__buffer.getShort(offset);
			offset += stride;
		}
		return result;
	}

	@Override
	protected void setArray(int offset, short[] result) {
		for (int i = 0; i < length; i++) {
			__nio__buffer.putShort(offset, result[i]);
			offset += stride;
		}
	}

	@Override
	public shortArrayViewSpaced clone() {
		return super.clone(new shortArrayViewSpaced(alignment(), length));
	}

	@Override
	public shortArrayView clone(shortArrayView view) {
		assert (view instanceof shortArrayViewSpaced);
		return super.clone(view);
	}

	public shortArrayViewSpaced clone(shortArrayViewSpaced view) {
		return super.clone(view);
	}

	@Override
	public Class<short[]> javatype() {
		return short[].class;
	}


}
