package org.cakelab.nio.view.array.impl;

import org.cakelab.nio.view.array.shortArrayView;
import org.cakelab.nio.view.impl.ScalarViewArrayViewBase;
import org.cakelab.nio.view.scalar.shortView;

public class shortArrayViewUser<EV extends shortView> extends ScalarViewArrayViewBase<short[], EV> implements shortArrayView {

	public shortArrayViewUser(EV elemView, int length) {
		super(short[].class, elemView, length);
	}

	public shortArrayViewUser(shortArrayViewUser<EV> that) {
		super(that);
	}

	@Override
	public shortArrayViewUser<EV> clone() {
		return super.clone(new shortArrayViewUser<EV>(this));
	}

	@SuppressWarnings("unchecked")
	@Override
	public shortArrayView clone(shortArrayView view) {
		assert (view instanceof shortArrayViewUser);
		return super.clone((shortArrayViewUser<EV>)view);
	}

	public shortArrayViewUser<EV> clone(shortArrayViewUser<EV> view) {
		return super.clone(view);
	}

	@Override
	public Class<short[]> javatype() {
		return short[].class;
	}

	@Override
	public short get(int index) {
		elemView.offset(getIndexedOffset(index));
		return elemView.get();
	}

	@Override
	public void set(short value, int index) {
		elemView.offset(getIndexedOffset(index));
		elemView.set(value);
	}
	
	@Override
	public short[] newDataInstance() {
		return new short[length];
	}

	@Override
	protected short[] getArray(int offset, short[] result) {
		for (int i = 0; i < length; i++) {
			elemView.offset(offset);
			result[i] = elemView.get();
			offset += stride;
		}
		return result;
	}

	@Override
	protected void setArray(int offset, short[] result) {
		for (int i = 0; i < length; i++) {
			elemView.offset(offset);
			elemView.set(result[i]);
			offset += stride;
		}
	}

}
