package org.cakelab.nio.view.array;

import org.cakelab.nio.view.ArrayView;
import org.cakelab.nio.view.array.impl.intArrayViewPacked;
import org.cakelab.nio.view.array.impl.intArrayViewSpaced;
import org.cakelab.nio.view.array.impl.intArrayViewUser;
import org.cakelab.nio.view.scalar.intView;

public interface intArrayView extends ArrayView<int[]> {
	
	static final int STANDARD_ELEM_SIZE = Integer.BYTES;
	
	public static intArrayViewPacked create(int length) {
		return new intArrayViewPacked(length);
	}
	public static intArrayView create(short alignment, int length) {
		if (alignment > 1) return new intArrayViewSpaced(alignment, length);
		else return create(length);
	}
	public static <EV extends intView> intArrayViewUser<EV> create(EV elemView, int length) {
		return new intArrayViewUser<EV>(elemView, length);
	}
	
	
	int get(int index);
	void set(int value, int index);

	intArrayView clone();
	intArrayView clone(intArrayView view);

}
