package org.cakelab.nio.view.array;

import org.cakelab.nio.view.ArrayView;
import org.cakelab.nio.view.array.impl.longArrayViewPacked;
import org.cakelab.nio.view.array.impl.longArrayViewSpaced;
import org.cakelab.nio.view.array.impl.longArrayViewUser;
import org.cakelab.nio.view.scalar.longView;

public interface longArrayView extends ArrayView<long[]> {
	static final int STANDARD_ELEM_SIZE = Long.BYTES;
	
	public static longArrayViewPacked create(int length) {
		return new longArrayViewPacked(length);
	}
	public static longArrayView create(short alignment, int length) {
		if (alignment > 1) return new longArrayViewSpaced(alignment, length);
		else return create(length);
	}
	public static <EV extends longView> longArrayViewUser<EV> create(EV elemView, int length) {
		return new longArrayViewUser<EV>(elemView, length);
	}
	
	
	long get(int index);
	void set(long value, int index);

	longArrayView clone();
	longArrayView clone(longArrayView view);

}
