package org.cakelab.nio.view.array;

import org.cakelab.nio.view.ArrayView;
import org.cakelab.nio.view.array.impl.shortArrayViewPacked;
import org.cakelab.nio.view.array.impl.shortArrayViewSpaced;
import org.cakelab.nio.view.array.impl.shortArrayViewUser;
import org.cakelab.nio.view.scalar.shortView;

public interface shortArrayView extends ArrayView<short[]> {
	
	static final int STANDARD_ELEM_SIZE = Short.BYTES;
	
	public static shortArrayViewPacked create(int length) {
		return new shortArrayViewPacked(length);
	}
	public static shortArrayView create(short alignment, int length) {
		if (alignment > 1) return new shortArrayViewSpaced(alignment, length);
		else return create(length);
	}
	public static <EV extends shortView> shortArrayViewUser<EV> create(EV elemView, int length) {
		return new shortArrayViewUser<EV>(elemView, length);
	}
	
	
	short get(int index);
	void set(short value, int index);

	shortArrayView clone();
	shortArrayView clone(shortArrayView view);

}
