package test.array.view;

import java.nio.ByteOrder;

import org.cakelab.nio.view.impl.DataViewBase;
import org.cakelab.nio.view.scalar.intView;

public class int24View extends DataViewBase implements intView {

	public int24View(int24View that) {
		super(that);
	}

	public int24View() {
		super((short)1);
	}

	public int24View(short alignment) {
		super(alignment);
	}

	private static final int MASK = 0xffffff;

	@Override
	public int sizeof() {
		return 3;
	}

	@Override
	public Class<?> javatype() {
		return int.class;
	}

	@Override
	public int get() {
		int n = 0;
		if (__nio__buffer.order() == ByteOrder.BIG_ENDIAN) {
			n |= (__nio__buffer.get(__nio__offset+0)&0xff) << 24;
			n |= (__nio__buffer.get(__nio__offset+1)&0xff) << 16;
			n |= (__nio__buffer.get(__nio__offset+2)&0xff) <<  8;
		} else {
			n |= (__nio__buffer.get(__nio__offset+0)&0xff) <<  8;
			n |= (__nio__buffer.get(__nio__offset+1)&0xff) << 16;
			n |= (__nio__buffer.get(__nio__offset+2)&0xff) << 24;
		}
		return toJavaInt(n);
	}

	@Override
	public void set(int value) {
		int n = toNativeInt(value);
		if (__nio__buffer.order() == ByteOrder.BIG_ENDIAN) {
			__nio__buffer.put(__nio__offset+0, (byte)((n>>>24)&0xff));
			__nio__buffer.put(__nio__offset+1, (byte)((n>>>16)&0xff));
			__nio__buffer.put(__nio__offset+2, (byte)((n>>> 8)&0xff));
		} else {
			__nio__buffer.put(__nio__offset+0, (byte)((n>>> 8)&0xff));
			__nio__buffer.put(__nio__offset+1, (byte)((n>>>16)&0xff));
			__nio__buffer.put(__nio__offset+2, (byte)((n>>>24)&0xff));
		}
	}


	@Override
	public intView clone() {
		return super.clone(new int24View(this));
	}

	@Override
	public intView clone(intView view) {
		return super.clone(view);
	}

	public static int toJavaInt(int nativeInt) {
		// using 'signed' shift preserves the sign at first position
		return (nativeInt>>8)&MASK;
	}

	public static int toNativeInt(int javaInt) {
		// using 'signed' shift preserves the sign at first position
		return ((javaInt&MASK)<<8);
	}

}
