package test.struct;

import java.nio.FloatBuffer;

import org.cakelab.nio.view.ReusableDataView;
import org.cakelab.nio.view.impl.StructViewBase;
import org.joml.Matrix4f;

/**
 * Another example of a user implemented view -- here it provides a view on a JOML Matrix4f instance.
 * @author homac
 *
 */
public class Matrix4fView extends StructViewBase<Matrix4f> implements ReusableDataView<Matrix4f> {

	private static final int SIZEOF_FLOAT = Float.BYTES;

	public Matrix4fView(short alignment) {
		super(alignment);
	}
	
	
	@Override
	public int sizeof() {
		return 4*4*SIZEOF_FLOAT;
	}

	@Override
	public Matrix4f newDataInstance() {
		return __nio__newStructInstance();
	}

	public static Matrix4f __nio__newStructInstance() {
		return new Matrix4f();
	}

	@Override
	public Matrix4f get() {
		return get(__nio__newStructInstance());
	}

	@Override
	public void set(Matrix4f v) {
		int reset = __nio__buffer.position();
		__nio__buffer.position(this.__nio__offset);
		FloatBuffer tmpBuffer = __nio__buffer.asFloatBuffer();
		tmpBuffer.put(v.m00());
		tmpBuffer.put(v.m01());
		tmpBuffer.put(v.m02());
		tmpBuffer.put(v.m03());
		tmpBuffer.put(v.m10());
		tmpBuffer.put(v.m11());
		tmpBuffer.put(v.m12());
		tmpBuffer.put(v.m13());
		tmpBuffer.put(v.m20());
		tmpBuffer.put(v.m21());
		tmpBuffer.put(v.m22());
		tmpBuffer.put(v.m23());
		tmpBuffer.put(v.m30());
		tmpBuffer.put(v.m31());
		tmpBuffer.put(v.m32());
		tmpBuffer.put(v.m33());
		__nio__buffer.position(reset);
	}

	@Override
	public Matrix4f get(Matrix4f result) {
		int reset = __nio__buffer.position();
		__nio__buffer.position(this.__nio__offset);
		FloatBuffer tmpBuffer = __nio__buffer.asFloatBuffer();
		result.m00(tmpBuffer.get());
		result.m01(tmpBuffer.get());
		result.m02(tmpBuffer.get());
		result.m03(tmpBuffer.get());
		result.m10(tmpBuffer.get());
		result.m11(tmpBuffer.get());
		result.m12(tmpBuffer.get());
		result.m13(tmpBuffer.get());
		result.m20(tmpBuffer.get());
		result.m21(tmpBuffer.get());
		result.m22(tmpBuffer.get());
		result.m23(tmpBuffer.get());
		result.m30(tmpBuffer.get());
		result.m31(tmpBuffer.get());
		result.m32(tmpBuffer.get());
		result.m33(tmpBuffer.get());
		__nio__buffer.position(reset);
		return result;
	}


	@Override
	public Matrix4fView clone() {
		return super.clone(new Matrix4fView(this.alignment()));
	}


	@Override
	public Class<Matrix4f> javatype() {
		return Matrix4f.class;
	}

}
